blob: 621fc24a263d2a833f272b15e6b2dbb0f8d775d1 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Alex Lightb55f1ac2016-04-12 15:50:55 -070049export SMALI_ARGS="--experimental"
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
83 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86
84fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
jeffhao5d1ac922011-09-29 17:41:15 -070093info="info.txt"
94build="build"
95run="run"
96expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -070097check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -070098output="output.txt"
99build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100100cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700101strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700102lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700103testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700104run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000105build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700106
Alex Light91de25f2015-10-28 17:00:06 -0700107quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000108debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700109prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700110target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700111dev_mode="no"
112update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700113debug_mode="no"
114relocate="yes"
Jeff Hao201803f2013-11-20 18:11:39 -0800115runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700116usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700117build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700118suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700119trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700120trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700121basic_verify="false"
122gc_verify="false"
123gc_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700125always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700126never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700127have_dex2oat="yes"
128have_patchoat="yes"
129have_image="yes"
Andreas Gampec23c9c92014-10-28 14:47:25 -0700130pic_image_suffix=""
Jeff Haodcdc85b2015-12-04 14:06:18 -0800131multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000132android_root="/system"
Alex Light10bc5a42016-05-10 10:01:22 -0700133# By default we will use optimizing.
134image_args=""
135image_suffix="-optimizing"
jeffhao5d1ac922011-09-29 17:41:15 -0700136
137while true; do
138 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700140 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100141 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700142 shift
Alex Light91de25f2015-10-28 17:00:06 -0700143 elif [ "x$1" = "x--quiet" ]; then
144 quiet="yes"
145 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700146 elif [ "x$1" = "x--use-java-home" ]; then
147 if [ -n "${JAVA_HOME}" ]; then
148 export JAVA="${JAVA_HOME}/bin/java"
149 export JAVAC="${JAVA_HOME}/bin/javac -g"
150 else
151 echo "Passed --use-java-home without JAVA_HOME variable set!"
152 usage="yes"
153 fi
154 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800155 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700156 target_mode="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800157 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700158 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700159 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700160 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100161 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100162 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700163 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700164 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800165 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700166 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700167 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700168 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700169 shift
170 elif [ "x$1" = "x--dalvik" ]; then
171 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800172 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700173 shift
Alex Light03a112d2014-08-25 13:25:56 -0700174 elif [ "x$1" = "x--no-dex2oat" ]; then
175 have_dex2oat="no"
176 shift
177 elif [ "x$1" = "x--no-patchoat" ]; then
178 have_patchoat="no"
179 shift
180 elif [ "x$1" = "x--no-image" ]; then
181 have_image="no"
182 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700183 elif [ "x$1" = "x--pic-image" ]; then
184 pic_image_suffix="-pic"
185 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800186 elif [ "x$1" = "x--multi-image" ]; then
187 multi_image_suffix="-multi"
188 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700189 elif [ "x$1" = "x--pic-test" ]; then
190 run_args="${run_args} --pic-test"
191 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700192 elif [ "x$1" = "x--relocate" ]; then
193 relocate="yes"
194 shift
195 elif [ "x$1" = "x--no-relocate" ]; then
196 relocate="no"
197 shift
198 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100199 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700200 prebuild_mode="yes"
201 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700202 elif [ "x$1" = "x--strip-dex" ]; then
203 run_args="${run_args} --strip-dex"
204 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000205 elif [ "x$1" = "x--debuggable" ]; then
206 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000207 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000208 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700209 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100210 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700211 prebuild_mode="no"
212 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700213 elif [ "x$1" = "x--gcverify" ]; then
214 basic_verify="true"
215 gc_verify="true"
216 shift
217 elif [ "x$1" = "x--gcstress" ]; then
218 basic_verify="true"
219 gc_stress="true"
220 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700221 elif [ "x$1" = "x--image" ]; then
222 shift
223 image="$1"
224 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700225 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000226 elif [ "x$1" = "x-Xcompiler-option" ]; then
227 shift
228 option="$1"
229 run_args="${run_args} -Xcompiler-option $option"
230 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700231 elif [ "x$1" = "x--runtime-option" ]; then
232 shift
233 option="$1"
234 run_args="${run_args} --runtime-option $option"
235 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700236 elif [ "x$1" = "x--gdb-arg" ]; then
237 shift
238 gdb_arg="$1"
239 run_args="${run_args} --gdb-arg $gdb_arg"
240 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700241 elif [ "x$1" = "x--debug" ]; then
242 run_args="${run_args} --debug"
243 shift
244 elif [ "x$1" = "x--gdb" ]; then
245 run_args="${run_args} --gdb"
246 dev_mode="yes"
247 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700248 elif [ "x$1" = "x--strace" ]; then
249 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700250 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700251 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700252 elif [ "x$1" = "x--zygote" ]; then
253 run_args="${run_args} --zygote"
254 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800255 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000256 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700257 image_suffix="-interpreter"
258 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800259 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700260 image_args="--jit"
Andreas Gampe8a159fd2015-09-21 15:14:38 -0700261 image_suffix="-jit"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800262 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700263 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700264 image_args="-Xcompiler-option --compiler-backend=Optimizing"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700265 image_suffix="-optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800266 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700267 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700268 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700269 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700270 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700271 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700272 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700273 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700274 elif [ "x$1" = "x--no-optimize" ]; then
275 run_args="${run_args} --no-optimize"
276 shift
277 elif [ "x$1" = "x--no-precise" ]; then
278 run_args="${run_args} --no-precise"
279 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700280 elif [ "x$1" = "x--invoke-with" ]; then
281 shift
282 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700283 if [ "x$what" = "x" ]; then
284 echo "$0 missing argument to --invoke-with" 1>&2
285 usage="yes"
286 break
287 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700288 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700289 shift
290 elif [ "x$1" = "x--dev" ]; then
291 run_args="${run_args} --dev"
292 dev_mode="yes"
293 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700294 elif [ "x$1" = "x--build-only" ]; then
295 build_only="yes"
296 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100297 elif [ "x$1" = "x--build-with-javac-dx" ]; then
298 USE_JACK="false"
299 shift
300 elif [ "x$1" = "x--build-with-jack" ]; then
301 USE_JACK="true"
302 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700303 elif [ "x$1" = "x--output-path" ]; then
304 shift
305 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700306 if [ "x$tmp_dir" = "x" ]; then
307 echo "$0 missing argument to --output-path" 1>&2
308 usage="yes"
309 break
310 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700311 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000312 elif [ "x$1" = "x--android-root" ]; then
313 shift
314 if [ "x$1" = "x" ]; then
315 echo "$0 missing argument to --android-root" 1>&2
316 usage="yes"
317 break
318 fi
319 android_root="$1"
320 run_args="${run_args} --android-root $1"
321 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700322 elif [ "x$1" = "x--update" ]; then
323 update_mode="yes"
324 shift
325 elif [ "x$1" = "x--help" ]; then
326 usage="yes"
327 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700328 elif [ "x$1" = "x--64" ]; then
329 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700330 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700331 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200332 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700333 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200334 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700335 elif [ "x$1" = "x--stream" ]; then
336 trace_stream="true"
337 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700338 elif [ "x$1" = "x--always-clean" ]; then
339 always_clean="yes"
340 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700341 elif [ "x$1" = "x--never-clean" ]; then
342 never_clean="yes"
343 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800344 elif [ "x$1" = "x--dex2oat-swap" ]; then
345 run_args="${run_args} --dex2oat-swap"
346 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700347 elif [ "x$1" = "x--instruction-set-features" ]; then
348 shift
349 run_args="${run_args} --instruction-set-features $1"
350 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700351 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700352 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700353 usage="yes"
354 break
355 else
356 break
357 fi
358done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700359
Alex Light10bc5a42016-05-10 10:01:22 -0700360run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700361# Allocate file descriptor real_stderr and redirect it to the shell's error
362# output (fd 2).
363if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
364 exec {real_stderr}>&2
365else
366 # In bash before version 4.1 we need to do a manual search for free file
367 # descriptors.
368 FD=3
369 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
370 real_stderr=$FD
371 eval "exec ${real_stderr}>&2"
372fi
373if [ "$quiet" = "yes" ]; then
374 # Force the default standard output and error to go to /dev/null so we will
375 # not print them.
376 exec 1>/dev/null
377 exec 2>/dev/null
378fi
379
380function err_echo() {
381 echo "$@" 1>&${real_stderr}
382}
383
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700384# tmp_dir may be relative, resolve.
385#
386# Cannot use realpath, as it does not exist on Mac.
387# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700388# Cannot use readlink -m, as it does not exist on Mac.
389# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700390noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700391tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700392mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700393
Alex Lighte7873ec2014-08-12 09:53:50 -0700394if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800395 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
396 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700397fi
398if [ "$gc_verify" = "true" ]; then
399 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
400fi
401if [ "$gc_stress" = "true" ]; then
Alex Light97acf192016-03-17 09:59:38 -0700402 run_args="${run_args} --gc-stress --runtime-option -Xgc:SS,gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700403fi
Jeff Hao85139a32014-07-23 11:52:52 -0700404if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700405 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
406 if [ "$trace_stream" = "true" ]; then
407 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
408 # the ability to analyze the file and just write to /dev/null.
409 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
410 # Enable streaming mode.
411 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
412 else
413 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
414 fi
415elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700416 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700417 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700418fi
419
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700420# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100421# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100422function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100423 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800424 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700425 if [ "x${suffix64}" = "x64" ]; then
426 target_arch_name=${grep64bit}
427 else
428 target_arch_name=${grep32bit}
429 fi
430}
431
David Brazdil853a4c32015-09-28 16:15:50 +0100432function guess_host_arch_name() {
433 if [ "x${suffix64}" = "x64" ]; then
434 host_arch_name="x86_64"
435 else
436 host_arch_name="x86"
437 fi
438}
439
Alex Lighta59dd802014-07-02 16:28:08 -0700440if [ "$target_mode" = "no" ]; then
441 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700442 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700443 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700444 exit 1;
445 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700446 fi
447fi
448
Alex Light03a112d2014-08-25 13:25:56 -0700449if [ "$have_patchoat" = "no" ]; then
450 run_args="${run_args} --no-patchoat"
451fi
452
453if [ "$have_dex2oat" = "no" ]; then
454 run_args="${run_args} --no-dex2oat"
455fi
456
Jeff Hao201803f2013-11-20 18:11:39 -0800457if [ ! "$runtime" = "jvm" ]; then
458 run_args="${run_args} --lib $lib"
459fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700460
Jeff Hao201803f2013-11-20 18:11:39 -0800461if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700462 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100463 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800464 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700465 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700466 else
467 true # defaults to using target BOOTCLASSPATH
468 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800469elif [ "$runtime" = "art" ]; then
470 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100471 guess_host_arch_name
Jeff Haodcdc85b2015-12-04 14:06:18 -0800472 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700473 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800474 else
David Brazdil853a4c32015-09-28 16:15:50 +0100475 guess_target_arch_name
Dimitry Ivanov90d48f22016-05-05 17:24:28 -0700476 run_args="${run_args} --runtime-option -Djava.library.path=/data/art-test/${target_arch_name}:/system/lib${suffix64}"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800477 run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800478 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700479 if [ "$relocate" = "yes" ]; then
480 run_args="${run_args} --relocate"
481 else
482 run_args="${run_args} --no-relocate"
483 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700484elif [ "$runtime" = "jvm" ]; then
485 # TODO: Detect whether the host is 32-bit or 64-bit.
486 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700487fi
488
Alex Light03a112d2014-08-25 13:25:56 -0700489if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700490 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700491 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700492 exit 1
493 fi
494 if [ "$target_mode" = "no" ]; then
495 framework="${ANDROID_HOST_OUT}/framework"
496 bpath_suffix="-hostdex"
497 else
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000498 framework="${android_root}/framework"
Alex Light1ef4ce82014-08-27 11:13:47 -0700499 bpath_suffix=""
500 fi
501 # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will
502 # fail since these jar files will be stripped.
503 bpath="${framework}/core-libart${bpath_suffix}.jar"
Narayan Kamathd50687e2015-11-17 12:37:27 +0000504 bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700505 bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar"
506 bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar"
Alex Light1ef4ce82014-08-27 11:13:47 -0700507 bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar"
508 # Pass down the bootclasspath
509 run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}"
Alex Light03a112d2014-08-25 13:25:56 -0700510 run_args="${run_args} --no-image"
511fi
512
jeffhao5d1ac922011-09-29 17:41:15 -0700513if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700514 err_echo "--dev and --update are mutually exclusive"
515 usage="yes"
516fi
517
518if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
519 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700520 usage="yes"
521fi
522
523if [ "$usage" = "no" ]; then
524 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
525 test_dir=`basename "$oldwd"`
526 else
527 test_dir="$1"
528 fi
529
530 if [ '!' -d "$test_dir" ]; then
531 td2=`echo ${test_dir}-*`
532 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700533 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700534 usage="yes"
535 fi
536 test_dir="$td2"
537 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700538 # Shift to get rid of the test name argument. The rest of the arguments
539 # will get passed to the test run.
540 shift
541fi
542
543if [ "$usage" = "yes" ]; then
544 prog=`basename $prog`
545 (
546 echo "usage:"
547 echo " $prog --help Print this message."
548 echo " $prog [options] [test-name] Run test normally."
549 echo " $prog --dev [options] [test-name] Development mode" \
550 "(dumps to stdout)."
551 echo " $prog --update [options] [test-name] Update mode" \
552 "(replaces expected.txt)."
553 echo ' Omitting the test name or specifying "-" will use the' \
554 "current directory."
555 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000556 echo " -O Run non-debug rather than debug build (off by default)."
557 echo " -Xcompiler-option Pass an option to the compiler."
558 echo " --runtime-option Pass an option to the runtime."
559 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000560 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000561 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700562 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000563 echo " --build-only Build test files only (off by default)."
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100564 echo " --build-with-javac-dx Build test files with javac and dx (on by default)."
565 echo " --build-with-jack Build test files with jack and jill (off by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000566 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800567 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000568 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000569 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700570 echo " --verify-soft-fail Force soft fail verification (off by default)."
571 echo " Verification is enabled if neither --no-verify"
572 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000573 echo " --no-optimize Turn off optimization (on by default)."
574 echo " --no-precise Turn off precise GC (on by default)."
575 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700576 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000577 echo " other runtime options are ignored."
578 echo " --no-dex2oat Run as though dex2oat was failing."
579 echo " --no-patchoat Run as though patchoat was failing."
580 echo " --prebuild Run dex2oat on the files before starting test. (default)"
581 echo " --no-prebuild Do not run dex2oat on the files before starting"
582 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700583 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000584 echo " --relocate Force the use of relocating in the test, making"
585 echo " the image and oat files be relocated to a random"
586 echo " address before running. (default)"
587 echo " --no-relocate Force the use of no relocating in the test"
Alex Lightfadfee92015-10-28 09:40:10 -0700588 echo " --image Run the test using a precompiled boot image. (default)"
589 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000590 echo " --host Use the host-mode virtual machine."
591 echo " --invoke-with Pass --invoke-with option to runtime."
592 echo " --dalvik Use Dalvik (off by default)."
593 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700594 echo " --use-java-home Use the JAVA_HOME environment variable"
595 echo " to find the java compiler and runtime"
596 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000597 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700598 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000599 echo " --64 Run the test in 64-bit mode"
600 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700601 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700602 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000603 echo " --gcstress Run with gc stress testing"
604 echo " --gcverify Run with gc verification"
605 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700606 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000607 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000608 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700609 echo " --instruction-set-features [string]"
610 echo " Set instruction-set-features for compilation."
Alex Lightfadfee92015-10-28 09:40:10 -0700611 echo " --pic-image Use an image compiled with position independent code for the"
612 echo " boot class path."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800613 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
614 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700615 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700616 echo " --quiet Don't print anything except failure messages"
617 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700618 exit 1
619fi
620
621cd "$test_dir"
622test_dir=`pwd`
623
624td_info="${test_dir}/${info}"
625td_expected="${test_dir}/${expected}"
626
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700627if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700628 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700629 exit 1
630fi
631
632if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700633 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700634 exit 1
635fi
636
637# copy the test to a temp dir and run it
638
Elliott Hughes510c8782011-10-06 10:57:34 -0700639echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700640
641rm -rf "$tmp_dir"
642cp -Rp "$test_dir" "$tmp_dir"
643cd "$tmp_dir"
644
645if [ '!' -r "$build" ]; then
646 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800647else
648 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700649fi
650
651if [ '!' -r "$run" ]; then
652 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800653else
654 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700655fi
656
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700657if [ '!' -r "$check_cmd" ]; then
658 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800659else
660 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700661fi
662
jeffhao5d1ac922011-09-29 17:41:15 -0700663chmod 755 "$build"
664chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700665chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700666
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700667export TEST_NAME=`basename ${test_dir}`
668
Roland Levillain0d5a2812015-11-13 10:07:31 +0000669# arch_supports_read_barrier ARCH
670# -------------------------------
671# Return whether the Optimizing compiler has read barrier support for ARCH.
672function arch_supports_read_barrier() {
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000673 # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the
Roland Levillain0d5a2812015-11-13 10:07:31 +0000674 # moment.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000675 [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ]
Roland Levillain0d5a2812015-11-13 10:07:31 +0000676}
677
David Brazdil4846d132015-01-15 19:07:08 +0000678# Tests named '<number>-checker-*' will also have their CFGs verified with
679# Checker when compiled with Optimizing on host.
680if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
David Brazdilf02c3cf2016-02-29 09:14:51 +0000681 if [ "$runtime" = "art" -a "$image_suffix" = "-optimizing" -a "$USE_JACK" = "true" ]; then
Roland Levillain0d5a2812015-11-13 10:07:31 +0000682 # Optimizing has read barrier support for certain architectures
683 # only. On other architectures, compiling is disabled when read
684 # barriers are enabled, meaning that we do not produce a CFG file
685 # as a side-effect of compilation, thus the Checker assertions
686 # cannot be checked. Disable Checker for those cases.
687 #
688 # TODO: Enable Checker when read barrier support is added to more
689 # architectures (b/12687968).
690 if [ "x$ART_USE_READ_BARRIER" = xtrue ] \
691 && (([ "x$host_mode" = "xyes" ] \
692 && ! arch_supports_read_barrier "$host_arch_name") \
693 || ([ "x$target_mode" = "xyes" ] \
694 && ! arch_supports_read_barrier "$target_arch_name")); then
695 run_checker="no"
David Brazdil80fb3942015-07-23 11:53:42 +0100696 # In no-prebuild mode, the compiler is only invoked if both dex2oat and
697 # patchoat are available. Disable Checker otherwise (b/22552692).
Roland Levillain0d5a2812015-11-13 10:07:31 +0000698 elif [ "$prebuild_mode" = "yes" ] \
699 || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100700 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100701
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100702 if [ "$target_mode" = "no" ]; then
703 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100704 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100705 else
706 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100707 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100708 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100709
710 if [ "$debuggable" = "yes" ]; then
711 checker_args="$checker_args --debuggable"
712 fi
713
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100714 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100715 -Xcompiler-option -j1"
716 fi
David Brazdil4846d132015-01-15 19:07:08 +0000717 fi
718fi
719
Mathieu Chartier031768a2015-08-27 10:25:02 -0700720if [ "$runtime" != "jvm" ]; then
721 run_args="${run_args} --testlib ${testlib}"
722fi
723
Ian Rogers997f0f92014-06-21 22:58:05 -0700724# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB.
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100725build_file_size_limit=2048
726run_file_size_limit=2048
Alex Light4694e822016-01-22 10:09:40 -0800727
728# Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with
729# large amounts of expected output or large generated files.
730if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100731 build_file_size_limit=5120
732 run_file_size_limit=5120
Ian Rogers997f0f92014-06-21 22:58:05 -0700733fi
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100734if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then
735 # We will need to `adb pull` the .cfg output from the target onto the host to
736 # run checker on it. This file can be big.
Roland Levillain22ccc3a2015-11-24 13:10:05 +0000737 build_file_size_limit=24576
738 run_file_size_limit=24576
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100739fi
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100740if [ ${USE_JACK} = "false" ]; then
741 # Set ulimit if we build with dx only, Jack can generate big temp files.
742 if ! ulimit -S "$build_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700743 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100744 fi
Ian Rogers997f0f92014-06-21 22:58:05 -0700745fi
746
jeffhao5d1ac922011-09-29 17:41:15 -0700747good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000748good_build="yes"
749good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700750if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000751 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700752 build_exit="$?"
753 echo "build exit status: $build_exit" 1>&2
754 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100755 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700756 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100757 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800758 echo "${test_dir}: running..." 1>&2
759 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700760 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000761
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800762 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000763 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100764 if [ "$target_mode" = "yes" ]; then
765 adb pull $cfg_output_dir/$cfg_output &> /dev/null
766 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100767 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000768 checker_exit="$?"
769 if [ "$checker_exit" = "0" ]; then
770 good="yes"
771 fi
Alex Light91de25f2015-10-28 17:00:06 -0700772 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000773 else
774 good="yes"
775 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800776 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000777 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700778 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700779elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000780 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700781 build_exit="$?"
782 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100783 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700784 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100785 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800786 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700787 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000788 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100789 if [ "$target_mode" = "yes" ]; then
790 adb pull $cfg_output_dir/$cfg_output &> /dev/null
791 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100792 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000793 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700794 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
795 good="yes"
796 else
Alex Light91de25f2015-10-28 17:00:06 -0700797 cat "$build_output" 1>&${real_stderr} 1>&2
798 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700799 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700800elif [ "$build_only" = "yes" ]; then
801 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000802 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700803 build_exit="$?"
804 if [ "$build_exit" '!=' '0' ]; then
805 cp "$build_output" "$output"
806 echo "build exit status: $build_exit" >>"$output"
807 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
808 if [ "$?" '!=' "0" ]; then
809 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700810 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700811 fi
812 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700813 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700814 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700815 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700816else
David Brazdil4846d132015-01-15 19:07:08 +0000817 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700818 build_exit="$?"
819 if [ "$build_exit" = '0' ]; then
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100820 if ! ulimit -S "$run_file_size_limit"; then
Alex Light91de25f2015-10-28 17:00:06 -0700821 err_echo "ulimit file size setting failed"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100822 fi
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800823 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700824 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000825 run_exit="$?"
826 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700827 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000828 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000829 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100830 if [ "$target_mode" = "yes" ]; then
831 adb pull $cfg_output_dir/$cfg_output &> /dev/null
832 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100833 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000834 checker_exit="$?"
835 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700836 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000837 good_run="no"
838 else
839 good_run="yes"
840 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000841 else
842 good_run="yes"
843 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700844 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000845 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700846 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700847 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
848 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700849 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700850 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700851 max_name_length=$(getconf NAME_MAX ${tmp_dir})
852 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
853 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700854 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700855 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700856 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700857 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000858 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
859 # output == expected
860 good="yes"
861 echo "${test_dir}: succeeded!" 1>&2
862 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700863 fi
864fi
865
jeffhao5d1ac922011-09-29 17:41:15 -0700866(
Alex Lightbfac14a2014-07-30 09:41:21 -0700867 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700868 echo "${test_dir}: FAILED!"
869 echo ' '
870 echo '#################### info'
871 cat "${td_info}" | sed 's/^/# /g'
872 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700873 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700874 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700875 if [ "$strace" = "yes" ]; then
876 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700877 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700878 echo '####################'
879 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700880 echo ' '
881 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700882
Alex Light91de25f2015-10-28 17:00:06 -0700883) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700884
885# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700886if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700887 cd "$oldwd"
888 rm -rf "$tmp_dir"
889 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
890 adb shell rm -rf $DEX_LOCATION
891 fi
892 if [ "$good" = "yes" ]; then
893 exit 0
894 fi
895fi
896
897
898(
899 if [ "$always_clean" = "yes" ]; then
900 echo "${TEST_NAME} files deleted from host "
901 if [ "$target_mode" == "yes" ]; then
902 echo "and from target"
903 fi
904 else
905 echo "${TEST_NAME} files left in ${tmp_dir} on host"
906 if [ "$target_mode" == "yes" ]; then
907 echo "and in ${DEX_LOCATION} on target"
908 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700909 fi
910
Alex Light91de25f2015-10-28 17:00:06 -0700911) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700912
Alex Light6a870fa2016-05-31 16:36:19 -0700913if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
914 exit 0
915else
916 exit 1
917fi